# How to contribute
We welcome contributions from the community and are pleased to have them.  Please follow this guide when logging issues or making code changes.

## Logging Issues
All issues should be created using the [new issue form](https://github.com/xogroup/felicity/issues/new).

Clearly describe the issue including steps to reproduce if there are any.  Also, make sure to indicate the Felicity version that has the issue being reported.

## Patching Code
Code changes are welcome and should follow the guidelines below.

* Consult the existing [issues](https://github.com/xogroup/felicity/issues). If there is not already an issue discussing the changes you want to make, please open a [new one](https://github.com/xogroup/felicity/issues/new)! This gives us and the community an opportunity to discuss your ideas.
* Fork the repository on GitHub.
* Fix the issue ensuring that your code follows the [Hapi.js style guide](https://github.com/hapijs/contrib/blob/master/Style.md).
* Add tests for your new code ensuring that you have 100% code coverage (we can help you reach 100% but will not merge without it).
    * Run `npm run test-cover` to generate a report of test coverage for your own use.
* Pull requests should be made against the [master branch](https://github.com/xogroup/felicity/tree/master). Please fill out the provided form to the best of your ability. Help us help you!
